/* -- $Id: RTFConverter.java,v 1.5 2003/10/16 14:13:48 kshaikh Exp $ --
 Copyright (C) 2001 Auriga Logic <http://www.aurigalogic.com>
 Author: Khurshidali Shaikh <kshaikh@aurigalogic.com>

 ============================================================================
		    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
 ============================================================================

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
package com.aurigalogic.aurigadoc.core;

import java.io.*;

import org.xml.sax.InputSource;

/**
 * This class is used for converting AurigaDoc document to rtf.
 * 
 * @author <a href="mailto:kshaikh@aurigalogic.com">Khurshidali Shaikh</a>
 * @version $Revision: 1.5 $ $Date: 2003/10/16 14:13:48 $
 */

public class RTFConverter extends BaseConverter {

	/**
	 * Main method which does the conversion.
	 * @throws Exception exception
	 */
	public synchronized void convert() throws Exception {
		logInfo("Converting to RTF..");
		logInfo("Creating intermediate fo..");
		ByteArrayOutputStream os = new ByteArrayOutputStream();

		
		// first convert xml to xsl fo
		doTransform(new FileInputStream(inputFile), 
			os, getXSLForKey(XSL, XML2RTF), OUTPUT_XML);

		ByteArrayInputStream is = 
			new ByteArrayInputStream(os.toByteArray());


		logInfo("Converting fo to rtf..");
		String parentDir = (new File(outputFile)).getAbsolutePath();
		if (parentDir.lastIndexOf(File.separator) != -1) {
			parentDir = parentDir.substring(0, parentDir.lastIndexOf(File.separator));
		} else {
			parentDir = "/";
		}
		System.setProperty("user.dir", (new File(parentDir)).getAbsolutePath());
		FileOutputStream fos = new FileOutputStream(outputFile);
		// create rtf using jfor
		new org.jfor.jfor.converter.Converter(
			new InputSource(is),
			new BufferedWriter(new OutputStreamWriter(fos)),
			org.jfor.jfor.converter.Converter.createConverterOption()
		);
		fos.close();
	}
}
